#!/bin/bash
# 18) Copiar, eliminar determinados archivos o directorios

function gestion_archivos_y_directorios_borrar() {
    PARAM="${1}"
    CONT="${2}"
    # Rescatamos la acción a realizar: rm
    ACCION="$(jq -r ".${PARAM}[${CONT}].accion" "${FICHCONFJSON}")"
    # Rescatamos la lista de archivos y directorios a eliminar:
    ORIGENES=( $(jq -r ".${PARAM}[${CONT}].origenes" "${FICHCONFJSON}" | tr -s ";" " ") )
    EJECUTABLE="/usr/bin/vx-archivos-directorios"
    if [[ -x "${EJECUTABLE}" ]] && \
    "${EJECUTABLE}" "${ACCION}" "${ORIGENES[@]}" ; then
        "${echo_verde}" "=> ¡¡Ok!! Se han ${ACCION} correctamente los ${ORIGENES}"
    else
        "${echo_rojo}" "=> ¡¡Error!! No se han ${ACCION} correctamente los ${ORIGENES}"
    fi
}

"${echo_titulo}" "*  [[ Gestión de Archivos y Directorios - Borrar ... ]]  *"
PARAM="archivos_y_directorios.borrar.lista"
# check_parametro [parametro] [breve descripción] [función a llamar]
check_parametro "${PARAM}" "Borrar Archivos y Directorios" "gestion_archivos_y_directorios_borrar"

function gestion_archivos_y_directorios_copiar() {
    PARAM="${1}"
    CONT="${2}"
    # Rescatamos la acción a realizar: cp
    ACCION="$(jq -r ".${PARAM}[${CONT}].accion" "${FICHCONFJSON}")"
    # Rescatamos los directorios de destino de la copia:
    DESTINOS=( $(jq -r ".${PARAM}[${CONT}].destinos" "${FICHCONFJSON}" | tr -s ";" " ") )
    # Comprobamos si se tiene que copiar en el Escritorio del usuario gráfico:
    ENESCRITORIO="$(jq -r ".${PARAM}[${CONT}].inEscritorio" "${FICHCONFJSON}")"
    "${ENESCRITORIO}" && \
    DESTINOS+=( "$(vx-home-usuario-grafico)/Escritorio" )
    echo "=> La lista de destinos de la copia será: ${DESTINOS[*]}"
    # Rescatamos la lista de archivos y directorios a copiar en destino:
    ORIGENES=( $(jq -r ".${PARAM}[${CONT}].origenes" "${FICHCONFJSON}" | tr -s ";" " ") )
    # Rescatamos el propietario de los archivos en destino:
    PROPIETARIO="$(jq -r ".${PARAM}[${CONT}].propietario" "${FICHCONFJSON}")"
    
    EJECUTABLE="/usr/bin/vx-archivos-directorios"
    for DESTINO in "${DESTINOS[@]}" ; do
        if [[ -x "${EJECUTABLE}" ]] && \
        "${EJECUTABLE}" "${ACCION}" "${PROPIETARIO}" "${DESTINO}" "${ORIGENES[@]}" ; then
            "${echo_verde}" "=> ¡¡Ok!! Se han ${ACCION} correctamente los ${ORIGENES[*]} en ${DESTINO} para ${PROPIETARIO}"
        else
            "${echo_rojo}" "=> ¡¡Error!! No se han ${ACCION} correctamente los ${ORIGENES[*]} en ${DESTINO} para ${PROPIETARIO}"
        fi
    done
}

"${echo_titulo}" "*  [[ Gestión de Archivos y Directorios - Copiar ... ]]  *"
PARAM="archivos_y_directorios.copiar.lista"
# check_parametro [parametro] [breve descripción] [función a llamar]
check_parametro "${PARAM}" "Copiar Archivos y Directorios" "gestion_archivos_y_directorios_copiar"